Lucene++ - a full-featured, c++ search engine
API Documentation

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
Lucene::DocValues Class Referenceabstract

Represents field values as different types. Normally created via a `ValueSuorce` for a particular field and reader. More...

`#include <DocValues.h>`

Inheritance diagram for Lucene::DocValues:

## Public Member Functions

| DocValues ()
virtual | ~DocValues ()
virtual String | getClassName ()
boost::shared_ptr< DocValues > | shared_from_this ()
virtual double | doubleVal (int32_t doc)=0
| Return doc value as a double. Mandatory: every DocValues implementation must implement at least this method.
virtual int32_t | intVal (int32_t doc)
| Return doc value as an int. Optional: DocValues implementation can (but don't have to) override this method.
virtual int64_t | longVal (int32_t doc)
| Return doc value as a long. Optional: DocValues implementation can (but don't have to) override this method.
virtual String | strVal (int32_t doc)
| Return doc value as a string. Optional: DocValues implementation can (but don't have to) override this method.
virtual String | toString (int32_t doc)=0
| Return a string representation of a doc value, as required for Explanations.
virtual ExplanationPtr | explain (int32_t doc)
| Explain the scoring value for the input doc.
virtual CollectionValue | getInnerArray ()
| For test purposes only, return the inner array of values, or null if not applicable.
virtual double | getMinValue ()
| Returns the minimum of all values or NaN if this DocValues instance does not contain any value. This operation is optional.
virtual double | getMaxValue ()
| Returns the maximum of all values or NaN if this DocValues instance does not contain any value. This operation is optional.
virtual double | getAverageValue ()
| Returns the average of all values or NaN if this DocValues instance does not contain any value. This operation is optional.
virtual String | toString ()
| Returns a string representation of the object.
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed.
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object.
virtual int32_t | hashCode ()
| Return hash code for this object.
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal.
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects.
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock.
virtual LuceneSignalPtr | getSignal ()
| Return this object signal.
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout.
virtual void | unlock ()
| Unlock this object.
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread.
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout.
virtual void | notifyAll ()
| Notify all threads waiting for signal.

## Static Public Member Functions

static String | _getClassName ()

## Protected Member Functions

void | compute ()
| Compute optional values.
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Protected Attributes

double | minVal
double | maxVal
double | avgVal
bool | computed
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

Represents field values as different types. Normally created via a `ValueSuorce` for a particular field and reader.

DocValues is distinct from ValueSource because there needs to be an object created at query evaluation time that is not referenced by the query itself because:

- Query objects should be MT safe
- For caching, Query objects are often used as keys... you don't want the Query carrying around big objects

## Constructor & Destructor Documentation

## ◆ DocValues()

Lucene::DocValues::DocValues | ( |  | ) |

Referenced by _getClassName().

## ◆ ~DocValues()

virtual Lucene::DocValues::~DocValues | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

String Lucene::DocValues::_getClassName | ( |  | ) |

inline static

References DocValues().

## ◆ compute()

void Lucene::DocValues::compute | ( |  | ) |

protected

Compute optional values.

## ◆ doubleVal()

virtual double Lucene::DocValues::doubleVal | ( | int32_t | doc | ) |

pure virtual

Return doc value as a double. Mandatory: every DocValues implementation must implement at least this method.

Parameters

  doc | document whose double value is requested.

Implemented in Lucene::DoubleDocValues.

## ◆ explain()

virtual ExplanationPtr Lucene::DocValues::explain | ( | int32_t | doc | ) |

virtual

Explain the scoring value for the input doc.

## ◆ getAverageValue()

virtual double Lucene::DocValues::getAverageValue | ( |  | ) |

virtual

Returns the average of all values or NaN if this DocValues instance does not contain any value. This operation is optional.

Returns
  the average of all values or NaN if this DocValues instance does not contain any value.

## ◆ getClassName()

virtual String Lucene::DocValues::getClassName | ( |  | ) |

inline virtual

Reimplemented in Lucene::DoubleDocValues.

## ◆ getInnerArray()

virtual CollectionValue Lucene::DocValues::getInnerArray | ( |  | ) |

virtual

For test purposes only, return the inner array of values, or null if not applicable.

Allows tests to verify that loaded values are:

1. indeed cached/reused.
2. stored in the expected size/type (byte/short/int/float).

Note: implementations of DocValues must override this method for these test elements to be tested, Otherwise the test would not fail, just print a warning.

Reimplemented in Lucene::DoubleDocValues.

## ◆ getMaxValue()

virtual double Lucene::DocValues::getMaxValue | ( |  | ) |

virtual

Returns the maximum of all values or NaN if this DocValues instance does not contain any value. This operation is optional.

Returns
  the maximum of all values or NaN if this DocValues instance does not contain any value.

## ◆ getMinValue()

virtual double Lucene::DocValues::getMinValue | ( |  | ) |

virtual

Returns the minimum of all values or NaN if this DocValues instance does not contain any value. This operation is optional.

Returns
  the minimum of all values or NaN if this DocValues instance does not contain any value.

## ◆ intVal()

virtual int32_t Lucene::DocValues::intVal | ( | int32_t | doc | ) |

virtual

Return doc value as an int. Optional: DocValues implementation can (but don't have to) override this method.

Parameters

  doc | document whose int value is requested.

## ◆ longVal()

virtual int64_t Lucene::DocValues::longVal | ( | int32_t | doc | ) |

virtual

Return doc value as a long. Optional: DocValues implementation can (but don't have to) override this method.

Parameters

  doc | document whose long value is requested.

## ◆ shared_from_this()

boost::shared_ptr< DocValues > Lucene::DocValues::shared_from_this | ( |  | ) |

inline

## ◆ strVal()

virtual String Lucene::DocValues::strVal | ( | int32_t | doc | ) |

virtual

Return doc value as a string. Optional: DocValues implementation can (but don't have to) override this method.

Parameters

  doc | document whose string value is requested.

## ◆ toString() [1/2]

virtual String Lucene::LuceneObject::toString | ( |  | ) |

virtual

Returns a string representation of the object.

Reimplemented from Lucene::LuceneObject.

## ◆ toString() [2/2]

virtual String Lucene::DocValues::toString | ( | int32_t | doc | ) |

pure virtual

Return a string representation of a doc value, as required for Explanations.

Implemented in Lucene::DoubleDocValues.

## Field Documentation

## ◆ avgVal

double Lucene::DocValues::avgVal

protected

## ◆ computed

bool Lucene::DocValues::computed

protected

## ◆ maxVal

double Lucene::DocValues::maxVal

protected

## ◆ minVal

double Lucene::DocValues::minVal

protected

The documentation for this class was generated from the following file:

- DocValues.h

clucene.sourceforge.net